<%@ page language="java" contentType="text/html; charset=UTF-8" %>
<%@ page import="weaver.general.Util,java.util.*,java.io.*,java.util.regex.*,java.util.concurrent.*,weaver.hrm.*,org.apache.commons.lang.StringUtils,java.text.DateFormat" %>
<%
    response.setHeader("cache-control", "no-cache");
    response.setHeader("pragma", "no-cache");
    response.setHeader("expires", "Mon 1 Jan 1990 00:00:00 GMT");
	User user = HrmUserVarify.getUser (request , response) ;
	
	if(user==null){
		response.sendRedirect("/login/Login.jsp");
		return;
	}
	if(user.getUID() != 1){
		out.println("请使用sysadmin登录系统后访问该页面。");
		return;
	}
	ServletContext context = config.getServletContext();
	String ecPath = context.getRealPath("/");
	String raspPath = ecPath + "WEB-INF" + File.separator + "securityRule" + File.separator + "Rasp" + File.separator + "official.js";
	String ecMsg = "";
	String raspMsg = "";
	String result = "<p style='color:green;font-size: 30px;'>可靠的插件版本</p>";
	String resultMsg = "";
	File ec = new File(ecPath);
	if(!ec.exists() || !ec.isDirectory()) {
		ecMsg = "<p style='color:red;'>ecology路径读取异常，请手动检查更新</p>";
	} else {
		File rasp = new File(raspPath);
		if(!rasp.exists()) {
			raspMsg = "<p style='color:red;'>RASP插件读取异常，请检查是否部署RASP</p>";
			result = "<p style='color:red;'>更新失败</p>";
		} else {
			BufferedReader bufferedReader = new BufferedReader(new FileReader(raspPath));
            String str;
            while ((str = bufferedReader.readLine()) != null) {
                if (str.indexOf("plugin_version") > -1) {
					String version = str.split("=")[1].trim().substring(1,10);
					if (!"2022-1107".equals(version)) {
						result = "<p style='color:red;font-size: 30px;'>更新失败</p>";
						resultMsg = "<p style='color:red;'>请手动检查更新</p>";
					}
					break;
				}
            }
		}
	}
	String jarMsg = "";
	String jarCheck = "<p style='color:red;'>更新失败</p>";
	long versionNowInt = 0;
	if (System.getProperty("RaspVersion") != null) {
		String raspVersion = System.getProperty("RaspVersion");
		String[] tmps = raspVersion.trim().split("\\.");
		if (1 == tmps.length) {
			versionNowInt = Long.parseLong(tmps[0] + "000000000");
		} else if (2 == tmps.length) {
			int a = 3 - tmps[1].length();
			while (0 < a) {
				tmps[1] = "0" + tmps[1];
				a--;
			}
			versionNowInt = Long.parseLong(tmps[0] + tmps[1] + "000000");
		} else if (3 == tmps.length) {
			int a = 3 - tmps[1].length();
			while (0 < a) {
				tmps[1] = "0" + tmps[1];
				a--;
			}

			int c = 3 - tmps[2].length();
			while (0 < c) {
				tmps[2] = "0" + tmps[2];
				c--;
			}
			versionNowInt = Long.parseLong(tmps[0] + tmps[1] + tmps[2] + "000");
		} else if (4 == tmps.length) {

			int a = 3 - tmps[1].length();
			while (0 < a) {
				tmps[1] = "0" + tmps[1];
				a--;
			}

			int c = 3 - tmps[2].length();
			while (0 < c) {
				tmps[2] = "0" + tmps[2];
				c--;
			}

			int d = 3 - tmps[3].length();
			while (0 < d) {
				tmps[3] = "0" + tmps[3];
				d--;
			}
			versionNowInt = Long.parseLong(tmps[0] + tmps[1] + tmps[2] + tmps[3]);
		}
		if (versionNowInt == 2000005000L) {
			jarMsg = "";
			jarCheck = "<p style='color:green;font-size: 30px;'>可靠的RASP版本</p>";
		} else {
			jarMsg = "<p style='color:red;'>检测到老版本RASP</p>";
		}
	} else {
		jarMsg = "<p style='color:red;'>未检测到RASP运行,请根据部署手册手动检查RASP日志</p>";
	}
%>

<html>
<title>RASP更新检查</title>
<body>
<table width="100%" border="1" cellpadding="0" cellspacing="0">
    <thead>
    <th width="20%" style="text-align:center;">检查项</th>
    <th width="40%" style="text-align:center;">检查结果</th>
    <th width="40%" style="text-align:center;">详情及处置意见</th>
    </thead>
    <tbody>
	<tr>
		<td style="text-align:center;">ecology路径</td>
		<td style="text-align:center;"><%=ecPath%></td>
		<td style="text-align:center;"><%=ecMsg%></td>
	</tr>
	<tr>
		<td style="text-align:center;">RASP插件位置</td>
		<td style="text-align:center;"><%=raspPath%></td>
		<td style="text-align:center;"><%=raspMsg%></td>
	</tr>
	<tr>
		<td style="text-align:center;">插件更新信息</td>
		<td style="text-align:center;"><%=result%></td>
		<td style="text-align:center;"><%=resultMsg%></td>
	</tr>
	<tr>
		<td style="text-align:center;">JAR包更新信息</td>
		<td style="text-align:center;"><%=jarCheck%></td>
		<td style="text-align:center;"><%=jarMsg%></td>
	</tr>
	</tbody>
</table>
</body>
</html>
